/*
 * Copyright (c) 2014-2016 ISPRAS (http://www.ispras.ru)
 * Institute for System Programming of the Russian Academy of Sciences
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * ee the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <verifier/common.h>

enum
{
	LDV_NOT_DECLARED,
	LDV_DECLARED,
	LDV_COMPLETED,
};

static int ldv_completion_x = LDV_NOT_DECLARED;

/* MODEL_FUNC Initialize completion */
void ldv_init_completion_x(void)
{
	/* NOTE init  "x". */
	ldv_completion_x = LDV_DECLARED;
}

/* MODEL_FUNC Check if completion was not initialized and initialize completion */
void ldv_init_completion_macro_x(void)
{
	/* ASSERT Check if  "x" is declared.*/
	ldv_assert("linux:kernel:sched:completion::double init", ldv_completion_x != LDV_NOT_DECLARED);
	/* NOTE init  "x". */
	ldv_completion_x = LDV_DECLARED;
}

/* MODEL_FUNC Check if completion was initialized and wait for it */
void ldv_wait_for_completion_x(void)
{
	/* ASSERT Check if there was declaration for  "x".*/
	ldv_assert("linux:kernel:sched:completion::wait without init", ldv_completion_x != LDV_NOT_DECLARED);
	/* NOTE Set  "x" as completed. */
	ldv_completion_x = LDV_COMPLETED;
}

